<template>
    <div v-if="lang">
        <div class="no_data" v-if="!on_load && !show_data.length">
            当前无数据
        </div>
        <div class="table_config" v-if="(on_load && !this.show_data.length && is_auto_load) || (!is_auto_load && on_load)">
            <div class="fakeloader">
                <div class="fl spinner4"></div>
            </div>
        </div>
        <div class="tb_ct">
            <table class="base_tb_ct"  v-if="(!on_load && this.show_data.length) || (is_auto_load && on_load && this.show_data.length)">
                <thead>
                    <tr>
                        <th v-for="col in column_keys" v-if="col.views.includes($route.name)">
                            {{ col.name }}
                        </th>
                    </tr>
                </thead>

                <tr v-for="item, index in show_data" v-bind:class="{'': index%2 == 0}">
                    <td v-if="toggle_column_show(0)">
                        <div class="td_more_show w_48">
                            <router-link class="blue_ft" :to="{name: 'transaction_detail_view', params: {trx_id: item.trx_id}}">{{ item.trx_id }}</router-link>
                        </div>
                    </td>
                    <td v-if="toggle_column_show(1)">
                        <div>
                            <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.account}}">{{ item.account }}</router-link>
                        </div>
                    </td>
                    <td v-if="toggle_column_show(2)">
                        <div>
                            {{ item.name }}
                        </div>
                    </td>
                    <td v-if="toggle_column_show(3)">{{ item.block_time ? time_plus_hours(item.block_time) : 'T' }}</td>
                    <td v-if="toggle_column_show(4)">
                        <router-link class="blue_ft" :to="{name: 'block_detail_view', params: {block_num: item.block_num}}">{{ item.block_num }}</router-link>&nbsp;
                    </td>
                    <td v-if="toggle_column_show(5)">
                        <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.actor}}">{{ item.actor + '@' + item.permission }}</router-link>
                    </td>
                    <td v-if="toggle_column_show(6)">
                        <template v-for="name, index in get_related_accounts(item)" v-if="name">
                            <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: name}}">{{ name }}</router-link> 
                            <span v-if="name && index < get_related_accounts(item).length - 1">-> </span>
                        </template>
                    </td>

                    <td v-if="toggle_column_show(7)">
                        <span v-if="item.name != 'issue'">
                            {{ item.quantity || item.stake ? symblo_change(item.quantity || item.stake, 'BAS', item.token_type || 'BAS') : '' }}
                        </span>
                        <span v-if="item.name == 'issue'">
                            {{ item.quantity + ' ' + item.act.data.quantity.split(' ')[1] }}
                        </span>
                    </td>

                    <!-- <td v-if="toggle_column_show(6)">{{ item.account + ':' + item.name }}</td> -->
               </tr>
            </table>
        </div>
        <div class="tb_footer_ct" v-if="this.show_data.length">
            <div class="tb_page_actions">
                <a class="tb_page_item page_icon_left page_leftend_icon" v-if="this.page_index != 1" @click="get_data(1)"></a>
                <a class="tb_page_item page_icon_left" v-if="this.page_index != 1" @click="pre()"></a>
                <a 
                class="tb_page_item"
                v-for="item, index in page_list" 
                v-bind:class="{'tb_page_focus': item == page_index}"
                @click="get_data(item)"
                >
                {{item}}
                </a>
                <a class="tb_page_item page_icon page_icon_right" @click="next()"></a>
            </div>
        </div>
    </div>
</template>
<script>
import table_nav from '../common/table_nav.vue'
import {
    get_transactions
} from '../../service/eos_service.js'
import {
  get_value_by_type
} from '../../service/abi_manage'
import { lang } from '../../data/lang.js'
import { time_plus_hours, is_mobile, symblo_change } from '../utils/utils.js'
import load_fns from '../common/load_fns.js'
export default {
    data () {
        return {
            on_load: false,
            is_auto_load: false,
            has_more: true,
            load_timestamp: new Date().getTime(),
            data_timestamp: new Date().getTime(),
            page_index: 1,
            page_num: 1,
            page_items_num: 10,
            show_data: [],
            page_list: [],
            lang: lang.data,
            column_keys: [
                {
                    name: lang.data.transaction_id,
                    views: ['transaction_view', 'monitor_view'],
                },
                {
                    name: lang.data.contract_name,
                    views: ['transaction_view', 'monitor_view'],
                },
                {
                    name: lang.data.action_name,
                    views: ['transaction_view', 'monitor_view'],
                },
                {
                    name: lang.data.transaction_time,
                    views: ['transaction_view', 'monitor_view'],
                },
                {
                    name: lang.data.block_num,
                    views: ['transaction_view'],
                },
                {
                    name: lang.data.actor,
                    views: ['transaction_view'],
                },
                {
                    name: lang.data.transfer_direction,
                    views: ['transaction_view'],
                },
                {
                    name: lang.data.ammount,
                    views: ['transaction_view'],
                }
            ]
        }
    },
    mounted () {
        this.init();
        this.get_data(null, true);
        this.create_page_list();
    },
    destroyed () {
        this.reset();
    },
    watch: {
        'page_index' () {
            this.create_page_list();
        },
        'page_num' () {
            this.create_page_list();  
        }
    },
    methods: {
        init () {
            this.page_index = 1;
        },
        reset () {
            this.page_index = 0;
        },
        async get_data (page_index, is_auto) {
            this.page_index = !page_index ? this.page_index : page_index;
            if(!this.page_index) return ;
            this.is_auto_load = is_auto;
            let post_time = this.start_load( is_auto );
            let res = await get_transactions(this.page_index, this.page_items_num);
            if(!this.diff_data_timestamp(post_time)) return ;
            if(!res){
                this.finish_load();
                this.auto_update();
                return ;
            }
            this.page_num = res.data.total_page_num;
            this.show_data.splice(0, this.show_data.length, ...res.data.items)
            await this.update_item();
            this.finish_load();
            this.auto_update();
        },
        ...load_fns,
        symblo_change,
        toggle_column_show (index) {
            if(this.column_keys[index].views.includes(this.$route.name)) return true;
        },
        async update_item () {
          for(let item of this.show_data){
            let origin_data = JSON.parse(item.origin_data);
            origin_data = origin_data.traces ? origin_data.traces[0] : origin_data;
            let quantity = await get_value_by_type(origin_data, ['asset']);
            item.quantity = quantity.length ? quantity[0].value : '';
          }
        },
        get_related_accounts (item) {
            let trans = {
                    vote: ['voter', 'bpname'],
                    claim: ['bpname', 'voter'],
                    transfer: ['actor', 'to'],
                    unfreeze: ['bpname', 'actor'],
                    issue: ['actor', 'to'],
                    create: ['actor', 'issuer'],
                    newaccount: ['actor', 'name']
                },
                origin_data = JSON.parse(item.origin_data),
                _from, 
                _to = '', 
                res = [];
            
            origin_data = origin_data.traces ? origin_data.traces[0].act : origin_data.act;

            if(trans[item['name']]){
                let action_obs = trans[item['name']];
                _from = item[action_obs[0]];
                _to = (origin_data.data ? origin_data.data[action_obs[1]] : '') || item[action_obs[1]];
            }else{
                _from = item['actor'];
                _to = item['to'] || item['account'];
            }
            _from ? res.push(_from) : '';
            _to ? res.push(_to) : '';
            return res;
        },
        get_origin_data (item) {
            let {_from = '', to = '', bpname = '', voter = '', stake = '', quantity = '', memo = ''} = item;
            let name = item.name;
            // console.log(_from);
            if(name == 'vote'){
                return {voter, bpname, stake};
            }
            if(name == 'transfer'){
                return {_from, to, quantity, memo};
            }
            if(name == 'unfreeze'){
                return {voter, bpname};
            }
            if(name == 'claim'){
                return {voter, bpname};
            }
            if(name == 'newaccount'){
                return '';
            }
            if(name == 'updatebp'){
                return 'updatebp';
            }
        }
    }
}
</script>



